import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

import '../serializers.dart';

part 'loading_status.g.dart';

class LoadingStatus extends EnumClass {
  static const LoadingStatus initial = _$initial;
  static const LoadingStatus loading = _$loading;
  static const LoadingStatus error = _$error;
  static const LoadingStatus ready = _$ready;

  const LoadingStatus._(String name) : super(name);

  static BuiltSet<LoadingStatus> get values => _$loadingStatusValues;
  static LoadingStatus valueOf(String name) => _$loadingStatusValueOf(name);

  String serialize() {
    return blocExtraSerializers.serializeWith(LoadingStatus.serializer, this);
  }

  static LoadingStatus deserialize(String string) {
    return blocExtraSerializers.deserializeWith(
        LoadingStatus.serializer, string);
  }

  static Serializer<LoadingStatus> get serializer => _$loadingStatusSerializer;
}
