import 'package:built_collection/built_collection.dart';

import 'list_page.dart';

abstract class ListAdapter<TItem> {
  Future<TItem> create(TItem data);
  Future<void> delete(TItem item);
  Future<ListPage<TItem>> listPaginated({int page, int size});
  Future<BuiltList<TItem>> listAll();
  Future<TItem> retrieve(TItem item);
  Future<TItem> update(TItem data);
}
