import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';
import 'package:meta/meta.dart';

import '../serializers.dart';

part 'list_page.g.dart';

abstract class ListPage<T> implements Built<ListPage<T>, ListPageBuilder<T>> {
  static Serializer<ListPage> get serializer => _$listPageSerializer;
  factory ListPage({
    @required Iterable<T> items,
    bool hasNext,
    bool hasPrev,
    int pageSize,
    int pageNumber,
  }) =>
      _$ListPage<T>((b) => b..items.replace(items));
  ListPage._();

  bool get hasNext;
  bool get hasPrev;

  BuiltList<T> get items;

  int get page;
  int get size;

  Map<String, dynamic> toJson() {
    return blocExtraSerializers.serializeWith(ListPage.serializer, this);
  }

  static ListPage fromJson(Map<String, dynamic> json) {
    return blocExtraSerializers.deserializeWith(ListPage.serializer, json);
  }
}
