part of 'simple_list_bloc.dart';

abstract class _SimpleListEvent<TItem> {
  const _SimpleListEvent();
}

class LoadItemsEvent<T> extends _SimpleListEvent<T> {}

abstract class _SingleItemEvent<T> extends _SimpleListEvent<T> {
  final T item;

  const _SingleItemEvent(this.item) : assert(item != null);
}

class CreateItemEvent<T> extends _SingleItemEvent<T> {
  const CreateItemEvent(T item) : super(item);
}

class ReloadItemEvent<T> extends _SingleItemEvent<T> {
  const ReloadItemEvent(T item) : super(item);
}

class UpdateItemEvent<T> extends _SingleItemEvent<T> {
  final T updates;

  const UpdateItemEvent(
    T item,
    this.updates,
  ) : super(item);
}

class DeleteItemEvent<T> extends _SingleItemEvent<T> {
  const DeleteItemEvent(T item) : super(item);
}
