import 'package:built_value/serializer.dart';

import 'common/common.dart';
import 'list/list.dart';

part 'serializers.g.dart';

@SerializersFor([
  ListPage,
  SimpleListState,
])
final Serializers _internalSerializers = _$_internalSerializers;

Serializers _serializers;

Serializers get blocExtraSerializers => _serializers ??= _internalSerializers;
set blocExtraSerializers(Serializers serializers) => _serializers = serializers;

extension BlocExtraSerializersBuilderExtension on SerializersBuilder {
  void applyBlocExtraSerializers() => merge(_internalSerializers);
}
